--- /dev/null
+#!/bin/sh
+#
+# Test the behavior of post with multiple recipients and the use of Bcc:
+#
+
+set -e
+
+if test -z "${MH_OBJ_DIR}"; then
+ srcdir=`dirname "$0"`/../..
+ MH_OBJ_DIR=`cd "$srcdir" && pwd`; export MH_OBJ_DIR
+fi
+
+. "${srcdir}/test/post/test-post-common.sh"
+
+#
+# Bcc test.
+#
+# It's worth pointing out here what's going on the SMTP protocol.
+#
+# If there are both sighted and unsighted addresses in the address list,
+# post calls verify_all_addresses() which results in ALL recipient
+# addresses being attempted, then the SMTP connection is reset, then
+# both the sighted and unsigned messages are sent (in different SMTP
+# transactions). Apparantly post has always done it this way.
+#
+
+cat > "${MH_TEST_DIR}/Mail/draft" <<EOF
+From: Mr Nobody <nobody@example.com>
+To: Somebody One <somebody1@example.com>,
+ Somebody Two <somebody2@example.com>
+Subject: Test Bcc
+Bcc: Somebody Three <somebody3@example.com>,
+ Somebody Four <somebody4@example.com>
+
+This is test of Bcc recipients.
+EOF
+
+cat > "${testname}.expected" <<EOF
+EHLO nosuchhost.example.com
+MAIL FROM:<nobody@example.com>
+RCPT TO:<somebody1@example.com>
+RCPT TO:<somebody2@example.com>
+RCPT TO:<somebody3@example.com>
+RCPT TO:<somebody4@example.com>
+RSET
+MAIL FROM:<nobody@example.com>
+RCPT TO:<somebody1@example.com>
+RCPT TO:<somebody2@example.com>
+DATA
+From: Mr Nobody <nobody@example.com>
+To: Somebody One <somebody1@example.com>,
+ Somebody Two <somebody2@example.com>
+Subject: Test Bcc
+Date:
+
+This is test of Bcc recipients.
+.
+RSET
+MAIL FROM:<nobody@example.com>
+RCPT TO:<somebody3@example.com>
+RCPT TO:<somebody4@example.com>
+DATA
+From: Mr Nobody <nobody@example.com>
+Date:
+Subject: Test Bcc
+BCC:
+
+------- Blind-Carbon-Copy
+
+From: Mr Nobody <nobody@example.com>
+To: Somebody One <somebody1@example.com>,
+ Somebody Two <somebody2@example.com>
+Subject: Test Bcc
+Date:
+
+This is test of Bcc recipients.
+
+------- End of Blind-Carbon-Copy
+.
+QUIT
+EOF
+
+test_post "${testname}.actual" "${testname}.expected"
+
+exit ${failed:-0}
static char from[BUFSIZ]; /* my network address */
static char sender[BUFSIZ]; /* my Sender: header */
static char efrom[BUFSIZ]; /* my Envelope-From: header */
+static char fullfrom[BUFSIZ]; /* full contents of From header */
static char signature[BUFSIZ]; /* my signature */
static char *filter = NULL; /* the filter for BCC'ing */
static char *subject = NULL; /* the subject field for BCC'ing */
mnfree (mp);
}
+ /*
+ * If this is a From:/Resent-From: header, save the full thing for
+ * later in case we need it for use when constructing a Bcc draft message
+ */
+
+ if ((msgstate == RESENT) ? (hdr->set & MRFM) : (hdr->set & MFRM)) {
+ strncpy(fullfrom, str, sizeof(fullfrom));
+ fullfrom[sizeof(fullfrom) - 1] = 0;
+ /*
+ * Strip off any trailing newlines
+ */
+
+ while (strlen(fullfrom) > 0 && fullfrom[strlen(fullfrom) - 1] == '\n') {
+ fullfrom[strlen(fullfrom) - 1] = '\0';
+ }
+ }
+
if (grp > 0 && (hdr->flags & HNGR)) {
advise (NULL, "%s: field does not allow groups", name);
badmsg++;
from[0] = '\0';
efrom[0] = '\0';
sender[0] = '\0';
+ fullfrom[0] = '\0';
if ((cp = getfullname ()) && *cp) {
strncpy (sigbuf, cp, sizeof(sigbuf));
if (tfile == NULL) adios("bcc", "unable to create temporary file");
strncpy (bccfil, tfile, sizeof(bccfil));
+ fprintf (out, "From: %s\n", fullfrom);
fprintf (out, "Date: %s\n", dtime (&tclock, 0));
if (msgid)
fprintf (out, "Message-ID: %s\n", message_id (tclock, 0));